use serde::{Deserialize, Serialize};
use crate::blockchain::{Block, Blockchain, Transaction};

#[derive(Debug, Clone, Serialize, Deserialize)]
pub enum MessageType {
    NewBlock(Block),
    NewTransaction(Transaction),
    GetBlocks,
    GetBlockchain,
    Blockchain(Blockchain),
    Ping,
    Pong,
}

#[derive(Debug, Clone, Serialize, Deserialize)]
pub struct NetworkMessage {
    pub message_type: MessageType,
    pub timestamp: chrono::DateTime<chrono::Utc>,
}